diff --git a/hw/arm/armv7m.c b/hw/arm/armv7m.c
index ed7d97f..5275e3a 100644
--- a/hw/arm/armv7m.c
+++ b/hw/arm/armv7m.c
@@ -31,7 +31,7 @@ static inline uint32_t bitband_addr(void * opaque, uint32_t addr)
 static uint32_t bitband_readb(void *opaque, hwaddr offset)
 {
     uint8_t v;
-    cpu_physical_memory_read(bitband_addr(opaque, offset), &v, 1);
+    address_space_read(bitband_addr(opaque, offset), &v, 1);
     return (v & (1 << ((offset >> 2) & 7))) != 0;
 }
 
@@ -43,12 +43,12 @@ static void bitband_writeb(void *opaque, hwaddr offset,
     uint8_t v;
     addr = bitband_addr(opaque, offset);
     mask = (1 << ((offset >> 2) & 7));
-    cpu_physical_memory_read(addr, &v, 1);
+    address_space_read(addr, &v, 1);
     if (value & 1)
         v |= mask;
     else
         v &= ~mask;
-    cpu_physical_memory_write(addr, &v, 1);
+    address_space_write(addr, &v, 1);
 }
 
 static uint32_t bitband_readw(void *opaque, hwaddr offset)
@@ -59,7 +59,7 @@ static uint32_t bitband_readw(void *opaque, hwaddr offset)
     addr = bitband_addr(opaque, offset) & ~1;
     mask = (1 << ((offset >> 2) & 15));
     mask = tswap16(mask);
-    cpu_physical_memory_read(addr, &v, 2);
+    address_space_read(addr, &v, 2);
     return (v & mask) != 0;
 }
 
@@ -72,12 +72,12 @@ static void bitband_writew(void *opaque, hwaddr offset,
     addr = bitband_addr(opaque, offset) & ~1;
     mask = (1 << ((offset >> 2) & 15));
     mask = tswap16(mask);
-    cpu_physical_memory_read(addr, &v, 2);
+    address_space_read(addr, &v, 2);
     if (value & 1)
         v |= mask;
     else
         v &= ~mask;
-    cpu_physical_memory_write(addr, &v, 2);
+    address_space_write(addr, &v, 2);
 }
 
 static uint32_t bitband_readl(void *opaque, hwaddr offset)
@@ -88,7 +88,7 @@ static uint32_t bitband_readl(void *opaque, hwaddr offset)
     addr = bitband_addr(opaque, offset) & ~3;
     mask = (1 << ((offset >> 2) & 31));
     mask = tswap32(mask);
-    cpu_physical_memory_read(addr, &v, 4);
+    address_space_read(addr, &v, 4);
     return (v & mask) != 0;
 }
 
@@ -101,12 +101,12 @@ static void bitband_writel(void *opaque, hwaddr offset,
     addr = bitband_addr(opaque, offset) & ~3;
     mask = (1 << ((offset >> 2) & 31));
     mask = tswap32(mask);
-    cpu_physical_memory_read(addr, &v, 4);
+    address_space_read(addr, &v, 4);
     if (value & 1)
         v |= mask;
     else
         v &= ~mask;
-    cpu_physical_memory_write(addr, &v, 4);
+    address_space_write(addr, &v, 4);
 }
 
 static const MemoryRegionOps bitband_ops = {
diff --git a/hw/arm/boot.c b/hw/arm/boot.c
index 8ba0e42..c89b533 100644
--- a/hw/arm/boot.c
+++ b/hw/arm/boot.c
@@ -281,8 +281,8 @@ static void set_kernel_args(const struct arm_boot_info *info)
         int cmdline_size;
 
         cmdline_size = strlen(info->kernel_cmdline);
-        cpu_physical_memory_write(p + 8, info->kernel_cmdline,
-                                  cmdline_size + 1);
+        address_space_write(p + 8, info->kernel_cmdline,
+                            cmdline_size + 1);
         cmdline_size = (cmdline_size >> 2) + 1;
         WRITE_WORD(p, cmdline_size + 2);
         WRITE_WORD(p, 0x54410009);
@@ -296,7 +296,7 @@ static void set_kernel_args(const struct arm_boot_info *info)
         atag_board_len = (info->atag_board(info, atag_board_buf) + 3) & ~3;
         WRITE_WORD(p, (atag_board_len + 8) >> 2);
         WRITE_WORD(p, 0x414f4d50);
-        cpu_physical_memory_write(p, atag_board_buf, atag_board_len);
+        address_space_write(p, atag_board_buf, atag_board_len);
         p += atag_board_len;
     }
     /* ATAG_END */
@@ -372,7 +372,7 @@ static void set_kernel_args_old(const struct arm_boot_info *info)
     }
     s = info->kernel_cmdline;
     if (s) {
-        cpu_physical_memory_write(p, s, strlen(s) + 1);
+        address_space_write(p, s, strlen(s) + 1);
     } else {
         WRITE_WORD(p, 0);
     }
diff --git a/hw/arm/musicpal.c b/hw/arm/musicpal.c
index 54548f3..e624d51 100644
--- a/hw/arm/musicpal.c
+++ b/hw/arm/musicpal.c
@@ -175,12 +175,12 @@ static void eth_rx_desc_put(uint32_t addr, mv88w8618_rx_desc *desc)
     cpu_to_le16s(&desc->buffer_size);
     cpu_to_le32s(&desc->buffer);
     cpu_to_le32s(&desc->next);
-    cpu_physical_memory_write(addr, desc, sizeof(*desc));
+    address_space_write(addr, desc, sizeof(*desc));
 }
 
 static void eth_rx_desc_get(uint32_t addr, mv88w8618_rx_desc *desc)
 {
-    cpu_physical_memory_read(addr, desc, sizeof(*desc));
+    address_space_read(addr, desc, sizeof(*desc));
     le32_to_cpus(&desc->cmdstat);
     le16_to_cpus(&desc->bytes);
     le16_to_cpus(&desc->buffer_size);
@@ -203,8 +203,8 @@ static ssize_t eth_receive(NetClientState *nc, const uint8_t *buf, size_t size)
         do {
             eth_rx_desc_get(desc_addr, &desc);
             if ((desc.cmdstat & MP_ETH_RX_OWN) && desc.buffer_size >= size) {
-                cpu_physical_memory_write(desc.buffer + s->vlan_header,
-                                          buf, size);
+                address_space_write(desc.buffer + s->vlan_header,
+                                    buf, size);
                 desc.bytes = size + s->vlan_header;
                 desc.cmdstat &= ~MP_ETH_RX_OWN;
                 s->cur_rx[i] = desc.next;
@@ -229,12 +229,12 @@ static void eth_tx_desc_put(uint32_t addr, mv88w8618_tx_desc *desc)
     cpu_to_le16s(&desc->bytes);
     cpu_to_le32s(&desc->buffer);
     cpu_to_le32s(&desc->next);
-    cpu_physical_memory_write(addr, desc, sizeof(*desc));
+    address_space_write(addr, desc, sizeof(*desc));
 }
 
 static void eth_tx_desc_get(uint32_t addr, mv88w8618_tx_desc *desc)
 {
-    cpu_physical_memory_read(addr, desc, sizeof(*desc));
+    address_space_read(addr, desc, sizeof(*desc));
     le32_to_cpus(&desc->cmdstat);
     le16_to_cpus(&desc->res);
     le16_to_cpus(&desc->bytes);
@@ -256,7 +256,7 @@ static void eth_send(mv88w8618_eth_state *s, int queue_index)
         if (desc.cmdstat & MP_ETH_TX_OWN) {
             len = desc.bytes;
             if (len < 2048) {
-                cpu_physical_memory_read(desc.buffer, buf, len);
+                address_space_read(desc.buffer, buf, len);
                 qemu_send_packet(qemu_get_queue(s->nic), buf, len);
             }
             desc.cmdstat &= ~MP_ETH_TX_OWN;
diff --git a/hw/arm/nseries.c b/hw/arm/nseries.c
index d9e61f7..1745d21 100644
--- a/hw/arm/nseries.c
+++ b/hw/arm/nseries.c
@@ -990,8 +990,8 @@ static void n800_gpmc_init(struct n800_s *s)
             (1 << 6) |		/* CSVALID */
             (4 << 0);		/* BASEADDRESS */
 
-    cpu_physical_memory_write(0x6800a078,		/* GPMC_CONFIG7_0 */
-                              &config7, sizeof(config7));
+    address_space_write(0x6800a078, /* GPMC_CONFIG7_0 */
+                        &config7, sizeof(config7));
 }
 
 /* Setup sequence done by the bootloader */
@@ -1003,7 +1003,7 @@ static void n8x0_boot_init(void *opaque)
     /* PRCM setup */
 #define omap_writel(addr, val)	\
     buf = (val);			\
-    cpu_physical_memory_write(addr, &buf, sizeof(buf))
+    address_space_write(addr, &buf, sizeof(buf))
 
     omap_writel(0x48008060, 0x41);		/* PRCM_CLKSRC_CTRL */
     omap_writel(0x48008070, 1);			/* PRCM_CLKOUT_CTRL */
@@ -1381,7 +1381,7 @@ static void n8x0_init(MachineState *machine,
                             sdram_size - 0x400000);
 
         n800_setup_nolo_tags(nolo_tags);
-        cpu_physical_memory_write(OMAP2_SRAM_BASE, nolo_tags, 0x10000);
+        address_space_write(OMAP2_SRAM_BASE, nolo_tags, 0x10000);
     }
 }
 